//----------------------------------------------------------------------//
// NyanFi																//
//  A[JCu쐬_CAO											//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include "Global.h"
#include "usr_arc.h"
#include "UserFunc.h"
#include "UserMdl.h"
#include "PackDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPackArcDlg *PackArcDlg = NULL;

//---------------------------------------------------------------------------
__fastcall TPackArcDlg::TPackArcDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TPackArcDlg::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);

	IncDirCheckBox->Checked = IniFile->ReadBoolGen(_T("PackArcDlgIncDir"));

	usr_ARC->ZipPrm_x	= IniFile->ReadIntGen(_T("ZipPrm_x"),	5);
	usr_ARC->ZipPrm_sfx = IniFile->ReadBoolGen(_T("ZipPrm_sfx"));
	usr_ARC->TarPrm_z	= IniFile->ReadIntGen(_T("TarPrm_z"),	6);

	FormatRadioGroup->ItemIndex = IniFile->ReadIntGen(_T("ArcFormat"));
	FormatRadioGroupClick(NULL);

	PerDirCheckBoxClick(NULL);
	if (ArcNameEdit->Enabled) {
		ArcNameEdit->SetFocus();
		ArcNameEdit->SelStart = ArcNameEdit->Text.Length();
	}
}
//---------------------------------------------------------------------------
void __fastcall TPackArcDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	IniFile->SavePosInfo(this);

	IniFile->WriteBoolGen(_T("PackArcDlgIncDir"),	IncDirCheckBox);
	IniFile->WriteIntGen(_T("ArcFormat"),			FormatRadioGroup);

	switch (FormatRadioGroup->ItemIndex) {
	case 0: //ZIP
		usr_ARC->ZipPrm_x	= (ParamComboBox->ItemIndex==0)? 0 : ParamComboBox->ItemIndex*2 - 1;
		IniFile->WriteIntGen(_T("ZipPrm_x"),	usr_ARC->ZipPrm_x);
		break;
	case 1: //7Z
		usr_ARC->ZipPrm_x	= (ParamComboBox->ItemIndex==0)? 0 : ParamComboBox->ItemIndex*2 - 1;
		usr_ARC->ZipPrm_sfx = SfxCheckBox->Checked;
		IniFile->WriteBoolGen(_T("ZipPrm_sfx"),	usr_ARC->ZipPrm_sfx);
		IniFile->WriteIntGen(_T("ZipPrm_x"),	usr_ARC->ZipPrm_x);
		break;
	case 4:	//TAR
		usr_ARC->TarPrm_z = ParamComboBox->ItemIndex;
		IniFile->WriteIntGen(_T("TarPrm_z"),	usr_ARC->TarPrm_z);
		break;
	}
}

//---------------------------------------------------------------------------
void __fastcall TPackArcDlg::PerDirCheckBoxClick(TObject *Sender)
{
	IncDirCheckBox->Enabled = PerDirCheckBox->Enabled && PerDirCheckBox->Checked;
	ArcNameEdit->Enabled	= !IncDirCheckBox->Enabled;
	if (!ArcNameEdit->Enabled) ArcNameEdit->Text = EmptyStr;
}

//---------------------------------------------------------------------------
void __fastcall TPackArcDlg::FormatRadioGroupClick(TObject *Sender)
{
	ParamComboBox->Enabled = false;
	ParamComboBox->Clear();
	SfxCheckBox->Checked   = false;
	SfxCheckBox->Enabled   = false;
	PasswordEdit->Text	   = EmptyStr;
	PasswordEdit->Color    = scl_BtnFace;
	PasswordEdit->Enabled  = false;

	UnicodeString fext;

	switch (FormatRadioGroup->ItemIndex) {
	case 0:	//ZIP
	case 1:	//7Z
		set_ComboBoxText(ParamComboBox,
			_T("k\n")
			_T("kx1\n")
			_T("kx3\n")
			_T("kx5 (ftHg)\n")
			_T("kx7\n")
			_T("kx9\n"));
		ParamComboBox->ItemIndex = (usr_ARC->ZipPrm_x + 1)/2;
		ParamComboBox->Enabled	 = true;

		//ZIP
		if (FormatRadioGroup->ItemIndex==0) {
			SfxCheckBox->Enabled	 = false;
			PasswordEdit->Color 	 = scl_Window;
			PasswordEdit->Enabled	 = true;
			fext.USET_T(".zip");
		}
		//7Z
		else {
			SfxCheckBox->Checked	 = usr_ARC->ZipPrm_sfx;
			SfxCheckBox->Enabled	 = true;
			PasswordEdit->Color 	 = !usr_ARC->ZipPrm_sfx? scl_Window : scl_BtnFace;
			PasswordEdit->Enabled	 = !usr_ARC->ZipPrm_sfx;
			fext.sprintf(_T("%s"), usr_ARC->ZipPrm_sfx? _T(".exe") : _T(".7z"));
		}
		break;

	case 2:	//LHA
		fext.USET_T(".lzh");
		break;

	case 3:	//CAB
		fext.USET_T(".cab");
		break;

	case 4:	//TAR
		set_ComboBoxText(ParamComboBox,
			_T("k\n")
			_T("kx gzip1\n")
			_T("kx gzip2\n")
			_T("kx gzip3\n")
			_T("kx gzip4\n")
			_T("kx gzip5\n")
			_T("kx gzip6 (ftHg)\n")
			_T("kx gzip7\n")
			_T("kx gzip8\n")
			_T("kx gzip9\n"));
		ParamComboBox->ItemIndex = usr_ARC->TarPrm_z;
		ParamComboBox->Enabled	 = true;
		fext.USET_T(".tar");
		break;
	}

	FextLabel->Caption = fext;
}

//---------------------------------------------------------------------------
void __fastcall TPackArcDlg::SfxCheckBoxClick(TObject *Sender)
{
	if (FormatRadioGroup->ItemIndex==1) {	//7z
		if (SfxCheckBox->Checked) {
			PasswordEdit->Text	  = EmptyStr;
			PasswordEdit->Color   = scl_BtnFace;
			PasswordEdit->Enabled = false;
			FextLabel->Caption	  = ".exe";
		}
		else {
			PasswordEdit->Color   = scl_Window;
			PasswordEdit->Enabled = true;
			FextLabel->Caption	  = ".7z";
		}
	}
}

//---------------------------------------------------------------------------
void __fastcall TPackArcDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift, _T(HELPTOPIC_FL) _T("#Pack"));
}
//---------------------------------------------------------------------------
